Unit QSFAR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSFAR(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; var E :Real;
                var ALFA :Real; var BETA :Real; var XA :Real;
                var E1 :Real; L1 :Integer; L2 :Integer);

implementation

procedure QSFAR(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; var E :Real;
                var ALFA :Real; var BETA :Real; var XA :Real;
                var E1 :Real; L1 :Integer; L2 :Integer);
var
IL,U,V,X,BD :Integer;
EPS,TAU,W,P,H,Z1,Z2,E2,E3,J1,J2,RINT3,RINT4,C,D,G,I,J,K,L,M,O,Q,R,S,T,
   BA,BB,BC,BF,BG,BH,BL,BM,BN,BO,BP,BQ,BR,BS,BT,BU,BV,BX,HM :Real;
MI,NI,Y,Z,NIS :Boolean;
BE :Array [0..4] of Real;
BI :Array [0..4] of Real;
BJ :Array [0..4] of Real;
BK :Array [0..4] of Real;
BW :Array [0..6] of Real;
const
SYS059 :Real = 1.7e38;
CON :Real = 2.0e-10;
CONT99 :Real = 0.999999;
CONE :Real = 1.0e-15;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57,_58,_59,_60,_61,_62,_63;
begin
RINT3 := 0.0;
RINT4 := 0.0;
NIS := ( A  > B );
if (  not ( (NIS) ) ) 
 then goto _1;
BA := A;
A := B;
B := BA;
_1:
V := 2;
EPS := E;
HM := CON;
XA := -SYS059;
Y := True;
X := 1;
C := 0.0;
D := 0.0;
G := 0.0;
I := 0.0;
if ( BETA-ALFA ) < 0
 then goto _2
 else if ( BETA-ALFA ) > 0
       then goto _4
       else goto _3;
_2:
BA := ALFA;
ALFA := BETA;
BETA := BA;
goto _4;
_3:
ALFA := ALFA-HM;
BETA := BETA+HM;
_4:
if ( B-100.0 ) < 0
 then goto _7
 else if ( B-100.0 ) > 0
       then goto _5
       else goto _5;
_5:
if ( A+100.0 ) < 0
 then goto _6
 else if ( A+100.0 ) > 0
       then goto _38
       else goto _6;
_6:
Y := False;
X := -1;
K := B;
E := E/2.0;
B := A;
A := ALFA;
goto _38;
_7:
X := -1;
O := A;
A := B;
B := O;
goto _38;
_8:
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _9;
BA := A;
A := B;
B := BA;
_9:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _10;
J1 := 0.0;
J2 := 0.0;
E1 := 0.0;
goto _37;
_10:
MI := ( ALFA  < BETA  ) and ( (A  <= ALFA  ) and ( ALFA  < B  ) or ( A  < BETA
      ) and ( BETA  <= B) );
if (  not ( (MI) ) ) 
 then goto _12;
ALFA := (ALFA-A)/W;
BETA := (BETA-A)/W;
TAU := (BETA-ALFA)/2.0;
if ( TAU-HM ) < 0
 then goto _11
 else if ( TAU-HM ) > 0
       then goto _12
       else goto _11;
_11:
TAU := HM;
_12:
Z2 := E/W;
H := 1.0;
Z1 := EPS/W;
P := 0.0;
E1 := 0.0;
J1 := 0.0;
J2 := 0.0;
_13:
if (  not MI ) 
 then goto _14;
if (  not ( (P  < BETA  ) and ( (P+H)  > ALFA  ) and ( H  > TAU) ) )
 then goto _14;
H := TAU;
if ( P  >= ALFA ) 
 then goto _14;
H := ALFA-P;
if ( H  < TAU ) 
 then H := TAU;
_14:
BM := H/2.0;
BL := W*BM;
BQ := BL*RO;
BO := H*0.25;
for BD:=1 to 5 do
 begin
  BI[BD-1] := F(A+W*(P+BO*(BD-1)));
_15:
 end;
_16:
if ( (L1+L2)  < 1.5  ) and ( BQ  <= 0.25 ) 
 then goto _17;
BN := Abs(BI[0]+BI[4]-4.0*(BI[1]+BI[3])+6.0*BI[2]);
goto _19;
_17:
BF := (A+W*(P+BM))*RO+FI;
for BD:=1 to 5 do
 begin
  BJ[BD-1] := BI[BD-1]*Sin(BF);
  BK[BD-1] := BI[BD-1]*Cos(BF);
_18:
 end;
BF := BJ[0]+BJ[4]-4.0*(BJ[1]+BJ[3])+6.0*BJ[2];
BN := BK[0]+BK[4]-4.0*(BK[1]+BK[3])+6.0*BK[2];
BN := EMax1((L1)*Abs(BF),(L2)*Abs(BN));
_19:
BN := BN*BM*0.42;
if ( Abs(BN)-Z1 ) < 0
 then goto _25
 else if ( Abs(BN)-Z1 ) > 0
       then goto _20
       else goto _20;
_20:
H := H/2.0;
if ( 64.0+H-64.0 ) < 0
 then goto _21
 else if ( 64.0+H-64.0 ) > 0
       then goto _24
       else goto _21;
_21:
if ( P ) < 0
 then goto _22
 else if ( P ) > 0
       then goto _23
       else goto _22;
_22:
if ( H/4.0 ) < 0
 then goto _23
 else if ( H/4.0 ) > 0
       then goto _24
       else goto _23;
_23:
XA := (P+A)*W;
P := P+2.0*H;
H := H*2.0;
goto _25;
_24:
BI[4] := BI[2];
BI[2] := BI[1];
BM := H*0.5;
BQ := W*BM*RO;
BO := H*0.25;
BP := P+BO;
BI[1] := F(A+W*BP);
BI[3] := F(A+W*(BP+BM));
goto _16;
_25:
E1 := E1+Abs(BN);
BF := (A+W*(P+BM))*RO+FI;
BT := Sin(BF);
BU := Cos(BF);
BL := W*BM;
BV := RO*BL;
BW[3] := Sin(BV);
BW[4] := Cos(BV);
if ( BV-0.33 ) < 0
 then goto _26
 else if ( BV-0.33 ) > 0
       then goto _27
       else goto _26;
_26:
BX := BV*0.5;
BW[5] := Sin(BX);
BW[6] := Cos(BX);
BE[0] := 0.2666667;
BE[1] := 0.7111111*BW[6];
BE[2] := 0.1555556*BW[4];
BE[3] := 0.7111111*BW[5];
BE[4] := 0.1555556*BW[3];
goto _28;
_27:
BW[0] := 1.0/BV;
BW[1] := BW[0]*BW[0];
BW[2] := BW[1]*BW[1];
BE[0] := 4.0*BW[1]*(BW[0]*(48.0*BW[1]-19.0)*BW[3]+3.0*(1.0-
    16.0*BW[1])*BW[4]);
BE[1] := 32.0*BW[1]*(BW[0]*(5.0-12.0*BW[1])*BW[3]-(1.0-12.0*
    BW[1])*BW[4])/3.0;
BE[2] := BW[0]*((3.0-46.0*BW[1]+96.0*BW[2])*BW[3]+2.0*BW[0]*
    (7.0-48.0*BW[1])*BW[4])/3.0;
BE[3] := -16.0*BW[1]*((1.0-3.0*BW[1])*BW[3]+3.0*BW[0]*BW[4])/
    3.0;
BE[4] := BW[0]*(BW[0]*(11.0-24.0*BW[1])*BW[3]-3.0*(1.0-8.0*
    BW[1])*BW[4])/3.0;
_28:
BR := BE[0]*BI[2]+BE[1]*(BI[1]+BI[3])+BE[2]*(BI[0]+BI[4]);
BS := BE[3]*(BI[3]-BI[1])+BE[4]*(BI[4]-BI[0]);
J1 := J1+(BT*BR+BU*BS)*BM;
J2 := J2+(BU*BR-BT*BS)*BM;
P := P+H;
BH := 1.0-P;
if ( 1.0+BH/64.0-1.0 ) < 0
 then goto _29
 else if ( 1.0+BH/64.0-1.0 ) > 0
       then goto _31
       else goto _29;
_29:
BG := (Abs(F(B))+Abs(BI[4]))*H/2.0;
if ( BG-Z2 ) < 0
 then goto _35
 else if ( BG-Z2 ) > 0
       then goto _30
       else goto _35;
_30:
E1 := E1+BG;
goto _35;
_31:
BI[0] := BI[4];
if ( BN-Z1/32.0 ) < 0
 then goto _32
 else if ( BN-Z1/32.0 ) > 0
       then goto _33
       else goto _33;
_32:
H := 2.0*H;
_33:
if ( H-BH ) < 0
 then goto _13
 else if ( H-BH ) > 0
       then goto _34
       else goto _13;
_34:
H := BH;
goto _13;
_35:
J1 := J1*W;
J2 := J2*W;
E1 := E1*W;
if (  not ( (NI) ) ) 
 then goto _36;
BA := B;
B := A;
A := BA;
_36:
if (  not ( (MI) ) ) 
 then goto _37;
ALFA := ALFA*W+A;
BETA := BETA*W+A;
_37:
case U of
 1: goto _42;
 2: goto _47;
end;
_38:
IL := 1;
J := B;
L := A;
E2 := E;
E := 1000.0;
_39:
B := L+V*X;
if ( (B-J)*X ) < 0
 then goto _41
 else if ( (B-J)*X ) > 0
       then goto _40
       else goto _41;
_40:
B := J;
_41:
U := 1;
goto _8;
_42:
RINT1 := J1;
RINT2 := J2;
Q := EMax1(Abs(J1)*(L1),Abs(J2)*(L2));
E3 := E1;
_43:
R := Q;
_44:
Z := False;
A := B;
B := L+(B-L)*V;
if ( (B-J)*X ) < 0
 then goto _46
 else if ( (B-J)*X ) > 0
       then goto _45
       else goto _46;
_45:
B := J;
_46:
U := 2;
goto _8;
_47:
RINT1 := RINT1+J1;
RINT2 := RINT2+J2;
Q := EMax1(Abs(J1)*(L1),Abs(J2)*(L2));
E3 := E3+E1;
if ( Q  = 0.  ) and ( R  = 0.0 ) 
 then goto _51;
_48:
if ( Q-CONT99*R ) < 0
 then goto _9
 else if ( Q-CONT99*R ) > 0
       then goto _44
       else goto _44;
_49:
S := Q/R;
S := Q*S/(1.0-S);
if ( S-E2 ) < 0
 then goto _50
 else if ( S-E2 ) > 0
       then goto _44
       else goto _44;
_50:
if (  not ( (Z) ) ) 
 then goto _58;
E3 := E3+S;
_51:
IL := IL+1;
BB := EMax1(Abs(RINT1)*(L1),Abs(RINT2)*(L2));
BB := E2*(1.0+BB);
if ( E3-BB ) < 0
 then goto _59
 else if ( E3-BB ) > 0
       then goto _52
       else goto _59;
_52:
if ( IL-1 ) < 0
 then goto _53
 else if ( IL-1 ) > 0
       then goto _53
       else goto _54;
_53:
BC := EMax1((Abs(RINT1-RINT3)/(1.0+Abs(RINT3))*(L1)),
    (Abs(RINT2-RINT4)/(1.0+Abs(RINT4))*(L2)));
if ( BC-E2 ) < 0
 then goto _56
 else if ( BC-E2 ) > 0
       then goto _54
       else goto _56;
_54:
RINT3 := RINT1;
RINT4 := RINT2;
EPS := EPS/IntPower(2.0,5);
if ( XA+SYS059 ) < 0
 then goto _55
 else if ( XA+SYS059 ) > 0
       then goto _59
       else goto _55;
_55:
if ( EPS-CONE ) < 0
 then goto _56
 else if ( EPS-CONE ) > 0
       then goto _57
       else goto _56;
_56:
E3 := BC;
goto _59;
_57:
A := L;
goto _39;
_58:
Z := True;
goto _43;
_59:
if ( (B  < ALFA  ) and ( X  = 1)  ) or ( (B  > BETA  ) and ( X  = (-1))
 ) 
 then goto _48;
E := E2;
A := L;
B := J;
C := C+RINT1;
G := G+RINT2;
D := C;
I := G;
if ( Y ) 
 then goto _62;
if ( X+1 ) < 0
 then goto _60
 else if ( X+1 ) > 0
       then goto _61
       else goto _60;
_60:
T := E3;
M := B;
B := K;
X := 1;
goto _38;
_61:
E3 := E3+T;
A := M;
E := 2.0*E;
_62:
E1 := E3;
RINT1 := D;
RINT2 := I;
if (  not ( (NIS) ) ) 
 then goto _63;
RINT1 := -RINT1;
RINT2 := -RINT2;
_63:
end;

end.
